// Gamma 5 (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

bool fsave(char *_fname, unsigned char *_pt, int _size)
{
	fp = fopen(_fname,"wb");
	printf ("cutting ... %s\n",_fname);
	fwrite(_pt, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x010);
	disk.ReadDATA(0x02, 0x01, 0x00, 0x01, 0x01, &buff[0x0000], 0x1000);
	disk.ReadDATA(0x04, 0x02, 0x00, 0x01, 0x01, &buff[0x1000], 0x0200);
	fsave("MUS00",buff,0x1200);
	fcut("MUS01", 0x04, 0x02, 0x00, 0x03, 0x01, 0x0000, 0x0900);
	fcut("VOI00", 0x00, 0x00, 0x00, 0x0a, 0x01, 0x0000, 0x0300);
	fcut("VOI01", 0x00, 0x00, 0x00, 0x0d, 0x01, 0x0000, 0x0300);
	return 0;
}

